﻿using MatrixLibrary.Matrix;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace XOR_NN
{
    class Program
    {
        static void Main(string[] args)
        {
            List<double[]> lstInput = new List<double[]>();
            lstInput.Add(new double[] { 0, 0 });
            lstInput.Add(new double[] { 0, 1 });
            lstInput.Add(new double[] { 1, 0 });
            lstInput.Add(new double[] { 1, 1 });

            List<double> lstOutput = new List<double>();
            lstOutput.Add(0);
            lstOutput.Add(1);
            lstOutput.Add(1);
            lstOutput.Add(0);

            int input_neurons = 2;
            int hidden_neurons = 8;
            int output_neurons = 1;

            Random objRandom = new Random();

            Matrix weights_0_1 = new Matrix(input_neurons, hidden_neurons);
            Matrix weights_1_2 = new Matrix(hidden_neurons, output_neurons);

            for(int i=0;i<input_neurons;i++)
            {
                for(int j=0;j<hidden_neurons;j++)
                {
                    weights_0_1[i, j] = objRandom.NextDouble();
                }
            }

            for (int i = 0; i < hidden_neurons; i++)
            {
                for (int j = 0; j < output_neurons; j++)
                {
                    weights_1_2[i, j] = objRandom.NextDouble();
                }
            }

            double learning_rate = 0.5;
            int epochs = 2000;

            for(int i=0;i<epochs;i++)
            {
                for(int batch=0;batch<lstInput.Count;batch++)
                {
                    double[] input = lstInput[batch];
                    double[] output = new double[] { lstOutput[batch] };
                    Matrix desired_output_matrix = Matrix.CreateRowMatrix(output);

                    Matrix Layer_0 = Matrix.CreateRowMatrix(input);

                    Matrix Layer_1 = MatrixMath.Sigmoid(MatrixMath.Multiply(Layer_0, weights_0_1));
                    Matrix Layer_2 = MatrixMath.Sigmoid(MatrixMath.Multiply(Layer_1, weights_1_2));

                    Matrix error = MatrixMath.Pow(MatrixMath.Subtract(Layer_2, desired_output_matrix), 2);

                    Matrix Layer_2_delta = MatrixMath.ElementWiseMultiplication(MatrixMath.Subtract(Layer_2, desired_output_matrix),
                        MatrixMath.SigmoidDerivative(Layer_2));
                    Matrix Layer_1_delta = MatrixMath.ElementWiseMultiplication(
                        MatrixMath.Multiply(Layer_2_delta, MatrixMath.Transpose(weights_1_2)),
                        MatrixMath.SigmoidDerivative(Layer_1));

                    Matrix weights_1_2_delta = MatrixMath.Multiply(MatrixMath.Transpose(Layer_1), Layer_2_delta);
                    Matrix weights_0_1_delta = MatrixMath.Multiply(MatrixMath.Transpose(Layer_0), Layer_1_delta);

                    weights_0_1 = MatrixMath.ElementWiseSubtraction(weights_0_1,
                        MatrixMath.Multiply(weights_0_1_delta, learning_rate));
                    weights_1_2 = MatrixMath.ElementWiseSubtraction(weights_1_2,
                        MatrixMath.Multiply(weights_1_2_delta, learning_rate));
                }
            }

            for (int i = 0; i < lstInput.Count; i++)
            {
                Matrix test_input = Matrix.CreateRowMatrix(lstInput[i]);
                Matrix Layer_1_FF = MatrixMath.Sigmoid(MatrixMath.Multiply(
                    test_input, weights_0_1
                    ));
                Matrix Layer_2_FF = MatrixMath.Sigmoid(MatrixMath.Multiply(
                    Layer_1_FF, weights_1_2
                    ));

                Console.WriteLine(String.Format("Input: {0} Output: {1}", test_input.ToString(), Layer_2_FF.ToString()));
            }
        }
    }
}
